%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Getting Normalization Right: Dealing with `Dimensional Constants' in
%Macroeconomics
%C. Cantore and P. Levine - University of Surrey and CIMS
%This software is distributed under the GNU general pubblic license.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%function used by the program NK_SOE_CES_steadystate_loop.m


function y=fun_NK_SOE_CES(x,betah, xih, hch, sigmah, zetah, varrhoh, lamh, alphah,...
                deltah, phi_ih, g_ih, phi_Bh, w, rhoIh, rhoI,...
                muh, mu, c, cy, iy, yss, csexp, isexp, gh, gyh, csimp, isimp,...
                Ah, PIE, C, I, PIEh, R, Rh, RRh, Rnh, MCh, kB, chiB, TBh, habh, tb,k)


Yh=exp(x(1));
TBh=tb*Yh;
PHh=exp(x(2));
%omega=exp(x(3))/(1+exp(x(3)));
%omegaI=exp(x(4))/(1+exp(x(4)));
wh=exp(x(3))/(1+exp(x(3)));
wIh=exp(x(4))/(1+exp(x(4)));

%omega= 1-csexp/(C/Yh); %1-omega=csexph/(cy*gdpr) % comment out for
%omega=1: omega    = M_.params(37);
PFh   = ((1-wh*PHh^(1-muh))/(1-wh))^(1/(1-muh)); 
Tauh  = (((1/PHh)^(1-muh)-wh)/(1-wh))^(1/(1-muh));%PHZh         = 1/(wzh+(1-wzh)*Tauh^(1-muzh))^(1/(1-muzh));
RERhC = (w+(1-w)*Tauh^(mu-1))^(1/(1-mu))/(1-wh+wh*Tauh^(muh-1))^(1/(1-muh));
RERhI = (w+(1-w)*Tauh^(mu-1))^(1/(1-mu))/(1-wIh+wIh*Tauh^(rhoIh-1))^(1/(1-rhoIh));
PIh   = (wIh*PHh^(1-rhoIh)+(1-wIh)*PFh^(1-rhoIh))^(1/(1-rhoIh));
Qh    = PIh; 
Kh    = ((1-alphah)*MCh*PHh*Yh)/((Rh+deltah)*Qh); %Rh-1
Ih    = (gh+deltah)*Kh; 
C1h   = MCh*PHh*alphah*Yh; 
Lh    = (Yh/((1-c)*Kh^(1-alphah)))^(1/alphah)/Ah;
Wh    = C1h/Lh; 
omega=1-csexp/((PHh/RERhC)^(-mu)*(C)/Yh)*PHh;
omegaI=1-isexp/((PHh/(PIh*RERhI))^(-rhoI)*(I)/Yh)*PHh;
CH    = (1-omega)*(PHh/RERhC)^(-mu)*(C);
IH    = (1-omegaI)*(PHh/(PIh*RERhI))^(-rhoI)*I;
IHh   = wIh*(PHh/PIh)^(-rhoIh)*Ih;
Ch    = (Yh-gyh*Yh-IHh-CH-IH)/(wh*PHh^(-muh));
C2h   = (Ch-lamh*C1h)/(1-lamh); 
MUCh  = (1-varrhoh)*(C2h/(1-habh)-habh/(1-habh)*C2h)^((1-varrhoh)*(1-sigmah)-1)*((1-Lh)^(varrhoh*(1-sigmah)));
MUNh  = -(C2h/(1-habh)-habh/(1-habh)*C2h)^((1-varrhoh)*(1-sigmah))*varrhoh*((1-Lh)^(varrhoh*(1-sigmah)-1));

%BFh          = 0;%!!!!!!!!!!!!!!!!!
%PHIsbfh      = kB*(1+Sh*BFh/(Yh*PHh))^chiB;
%TBh          = 1/(R*PHIsbfh)*BFh-BFh; %!!!!!!!!!!!!!!!

y=[Wh+(MUNh/MUCh);...
   PHh*Yh-Ch-PIh*Ih-PHh*gyh*Yh-TBh;...
   %1-omega-csexp/(C/Yh)...
   %1-omega-csexp/(C/Yh)];
   %CH-csexp*Yh;...
   %IH-isexp*Yh;...
   csimp-((1-wh)*(PFh)^(1-muh)*Ch)/Yh;...
   %isimp-((1-wIh)*(PFh/PIh)^(1-rhoIh)*Ih)/Yh];
   Tauh*yss/Yh-k];

